import type { SoundcloudActivityCollection, SoundcloudConnection, SoundcloudUser } from "../types";
import { Base } from ".";
export declare class Me extends Base {
    /**
     * @deprecated use getV2
     * Gets your own profile, or your ID if pass in a true param.
     */
    get: <B extends boolean>(returnID?: B) => Promise<B extends true ? number : SoundcloudUser>;
    /**
     * Gets your own profile, using the Soundcloud v2 API.
     */
    getV2: () => Promise<SoundcloudUser>;
    /**
     * @deprecated
     * Gets activities from your homepage.
     */
    activities: () => Promise<SoundcloudActivityCollection>;
    /**
     * @deprecated
     * Gets affiliated activities.
     */
    activitiesAffiliated: () => Promise<SoundcloudActivityCollection>;
    /**
     * @deprecated
     * Gets exclusive activities.
     */
    activitiesExclusive: () => Promise<SoundcloudActivityCollection>;
    /**
     * @deprecated
     * Gets your own activities only.
     */
    activitiesOwn: () => Promise<SoundcloudActivityCollection>;
    /**
     * @deprecated
     * Gets your app connections, id any.
     */
    connections: () => Promise<SoundcloudConnection[]>;
    /**
     * @deprecated
     * Gets a connection from its ID.
     */
    connection: (connectionID: number) => Promise<SoundcloudConnection>;
    /**
     * @deprecated
     * Gets your tracks.
     */
    tracks: () => Promise<import("../types").SoundcloudTrack[]>;
    /**
     * @deprecated
     * Gets your comments.
     */
    comments: () => Promise<import("../types").SoundcloudComment[]>;
    /**
     * @deprecated
     * Gets your favorites.
     */
    favorites: () => Promise<import("../types").SoundcloudTrack[]>;
    /**
     * @deprecated
     * Gets a favorite.
     */
    favorite: (userResolvable: string | number) => Promise<import("../types").SoundcloudTrack>;
    /**
     * @deprecated
     * Gets your followers.
     */
    followers: () => Promise<import("../types").SoundcloudUserCollection>;
    /**
     * @deprecated
     * Gets a follower.
     */
    follower: (userResolvable: string | number) => Promise<SoundcloudUser>;
    /**
     * @deprecated
     * Gets your followings.
     */
    followings: () => Promise<import("../types").SoundcloudUserCollection>;
    /**
     * @deprecated
     * Gets a following.
     */
    following: (userResolvable: string | number) => Promise<SoundcloudUser>;
    /**
     * @deprecated
     * Gets your playlists.
     */
    playlists: () => Promise<import("../types").SoundcloudPlaylist[]>;
    /**
     * @deprecated
     * Gets your social networking profiles.
     */
    webProfiles: () => Promise<import("../types").SoundcloudWebProfile[]>;
}
