import type { SoundcloudOptions } from "./types";
import { API } from "./API";
import { Apps, Comments, Me, Oembed, Playlists, Resolve, Tracks, Users, Util } from "./entities";
/**
 * The main class for interacting with the Soundcloud API.
 */
export default class Soundcloud {
    static clientId?: string;
    static oauthToken?: string;
    static proxy?: string;
    api: API;
    apps: Apps;
    comments: Comments;
    me: Me;
    oembed: Oembed;
    playlists: Playlists;
    resolve: Resolve;
    tracks: Tracks;
    users: Users;
    util: Util;
    constructor(options?: SoundcloudOptions);
    /**
     * @deprecated Use `new Soundcloud({ clientId, oauthToken, proxy })` instead.
     */
    constructor(clientID?: string, oauthToken?: string, options?: {
        proxy?: string;
    });
}
export * from "./entities";
export * from "./types";
export * from "./API";
